unit uDemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, StdCtrls, PEGrids, Buttons, PEPropertyEditor;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
		PEPropertyEditor1: TPEPropertyEditor;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
 PEProperty: TPECustomProperty;
begin
 PEPropertyEditor1.BeginUpdate;

 PEProperty := PEPropertyEditor1.Items.Add(ptDate);
 PEProperty.Name := 'DATE';
 PEProperty.Caption := 'Date property';

 PEProperty := PEPropertyEditor1.Items.Add(ptBoolean);
 PEProperty.Name := 'BOOLEAN';
 PEProperty.Caption := 'Boolean property';
 TPEBooleanProperty(PEProperty).ValueAsBoolean := true;

 PEProperty := PEPropertyEditor1.Items.Add(ptNumber);
 PEProperty.Name := 'NUMBER';
 PEProperty.Caption := 'Number property [-10..10]';
 PEProperty.Description := 'This is property with defined min-max range';
 PEProperty.Scale := 3;
 PEProperty.Required := true;
 PEProperty.UpdateMinMaxRange(-10, 10);

 PEProperty := PEPropertyEditor1.Items.Add(ptString);
 PEProperty.Name := 'STRING';
 PEProperty.Caption := 'String property';
 PEProperty.Length := 4;  //Always define a length of values of the string property
 
 PEProperty := PEPropertyEditor1.Items.Add(ptTime);
 PEProperty.Caption := 'Time property';
 PEProperty.Name := 'TIME';

 PEProperty := PEPropertyEditor1.Items.Add(ptDate);
 PEProperty.Caption := 'Property with values list';
 PEProperty.ValuesList.Add(DateToStr(Date));
 PEProperty.ValuesList.Add(DateToStr(Date+1));
 PEProperty.ValuesList.Add(DateToStr(Date+2));
 PEProperty.ValuesList.Add(DateToStr(Date+3));
 
 PEProperty := PEPropertyEditor1.Items.Add(ptString);
 PEProperty.Caption := 'Only list values';
 PEProperty.ValuesList.Add('First');
 PEProperty.ValuesList.Add('Second');
 PEProperty.ValuesList.Add('Third');
 PEProperty.OnlyValueList := true;     

 PEProperty := PEPropertyEditor1.Items.Add(ptString);
 PEProperty.Caption := 'Multiple list values';
 PEProperty.ValuesList.Add('First');
 PEProperty.ValuesList.Add('Second');
 PEProperty.ValuesList.Add('Third');
 PEProperty.MultipleValues := true;     

 PEProperty := PEPropertyEditor1.Items.Add(ptTime);
 PEProperty.Caption := 'Time property';
 PEProperty.Name := 'TIME';

 PEPropertyEditor1.EndUpdate;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 PEPropertyEditor1.Items.Clear;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 PEPropertyEditor1.AlphaSort;
end;                                         

procedure TForm1.Button4Click(Sender: TObject);
begin
 if (peoEditing in PEPropertyEditor1.Options) then begin
	PEPropertyEditor1.Options := PEPropertyEditor1.Options - [peoEditing];
	Button4.Caption := 'Make Readable'; 
 end else begin
	PEPropertyEditor1.Options := PEPropertyEditor1.Options + [peoEditing];
	Button4.Caption := 'Make ReadOnly'; 
 end;
end;

end.
